//----------------------------------------------------------------------------------------------------
//
//----------------------------------------------------------------------------------------------------
#include <avr/io.h>
#include <util/delay.h>
#include <string.h>
#include <stdlib.h>
#include <stdbool.h>
#include <stdio.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <string.h>

//----------------------------------------------------------------------------------------------------
// 
//----------------------------------------------------------------------------------------------------
#define F_CPU 8000000UL

//----------------------------------------------------------------------------------------------------
// 
//----------------------------------------------------------------------------------------------------

//----------------------------------------------------------------------------------------------------
// 
//----------------------------------------------------------------------------------------------------
#include "rfid.h"
#include "wh1602.h"
 
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 
//
#define DDR_COIL		DDRB
#define PORT_COIL		PORTB
#define COIL_BIT		1

//
#define DDR_BUZ			DDRD
#define PORT_BUZ		PORTD
#define BUZ_BIT			4
#define BUZ_TONE		166 //  uS  ()   (1000/KHz=uS ---> -6(166uS), -2(500uS) )
int TONE = BUZ_TONE/2; 
#define BUZ_Duration	150 //  mS 
int Duration = BUZ_Duration*10/TONE*100;

//
#define DDR_LEDS		DDRB
#define PORT_LEDS		PORTB
#define LEDG_BIT		3 //  - 
#define LEDR_BIT		4 //  - 
#define LED_FLASH		4 //    (  INFO)  4 ---> 400mS 
 
// 
#define DDR_BUTTON_READ  DDRD
#define PORT_BUTTON_READ PORTD
#define PIN_BUTTON_READ  PIND
#define BUTTON_READ      2

// 
#define DDR_BUTTON_WRITE  DDRD
#define PORT_BUTTON_WRITE PORTD
#define PIN_BUTTON_WRITE  PIND
#define BUTTON_WRITE      3

//   INFO
#define INFO_SPEED      100 // DELAY ms ---> 50ms*INFO_SPEED = 50*80 = 4000ms

// 
#define COMMAND_ID_NONE     0
// ID 
#define COMMAND_ID_READ_ID  1
// ID 
#define COMMAND_ID_WRITE_ID 2

 
//----------------------------------------------------------------------------------------------------
// 
//----------------------------------------------------------------------------------------------------
 
volatile unsigned char CommandID=COMMAND_ID_NONE;//  
volatile unsigned char CommandParam[5];//   ( )
unsigned char LastReadingID[5]={0xFF,0xFF,0xFF,0xFF,0xFF};//  ID 

int skip = 0; //   Skip INFO
int counteref = 0; //    ( ,  )
//----------------------------------------------------------------------------------------------------
// 
//----------------------------------------------------------------------------------------------------
void InitAVR(void);// 
void ReadCardID(void);// ID 
void WriteCardID(unsigned char id[5]);// ID 
void Skip_Info(void); //   INFO    (  INFO ,  )
void LEDs_off(void); //  
void Sound(void); //     
//----------------------------------------------------------------------------------------------------
//  
//----------------------------------------------------------------------------------------------------
int main(void)
{
 InitAVR(); 
 WH1602_Init(); 
 // 
 WH1602_SetTextUpLine("  RFID");
 WH1602_SetTextDownLine("125kHz  EM-Marin");
	Skip_Info();
	if (skip==0)
	{
 WH1602_SetTextUpLine(" :");
 WH1602_SetTextDownLine("Reset Read Write");
	Skip_Info();
	if (skip==0)
	{
 WH1602_SetTextUpLine("Skip INF > Press");
 WH1602_SetTextDownLine("KEY Read / Write");
 	Skip_Info();
	if (skip==0)
	{
 WH1602_SetTextUpLine("EM-Marin EM4305/");
 WH1602_SetTextDownLine("T5557/T5577     ");
 	Skip_Info();
	if (skip==0)
	{
 WH1602_SetTextUpLine("  - da-nie ");
 WH1602_SetTextDownLine("  radiokot.ru   ");	
	Skip_Info();
	if (skip==0)
	{
 WH1602_SetTextUpLine(" ");
 WH1602_SetTextDownLine("   RECTO ");
 	Skip_Info();
	if (skip==0)
	{
 WH1602_SetTextUpLine("     ");
 WH1602_SetTextDownLine("ShadS  BolshoyK");
 	Skip_Info();
	if (skip==0)
	{
 WH1602_SetTextUpLine(" ");
 WH1602_SetTextDownLine("  one-nick");
	Skip_Info();
	if (skip==0)
	{
 WH1602_SetTextUpLine(" Nick Pastushok ");
 WH1602_SetTextDownLine("1602 Upgrade VER");
 	Skip_Info();
	if (skip==0)
	{
 WH1602_SetTextUpLine(" UKRAUNE   2019 ");
 WH1602_SetTextDownLine("  Khmelnitskiy  ");
 	Skip_Info();
	}}}}}}}}}
 WH1602_SetTextUpLine("Press the KEY >>");
 WH1602_SetTextDownLine("Read/Skip  Write");
 LEDs_off(); //   INFO       (   Skip_Info(); )
 Sound(); //   
 Duration=Duration/2;
 _delay_ms(1000);

 
 
 
 sei();
 static unsigned char command_param[5];
 // 
 while(1)
 { 
  cli();
  for(unsigned char n=0;n<5;n++) command_param[n]=CommandParam[n];
  unsigned char command_id=CommandID;
  CommandID=COMMAND_ID_NONE;//   
  // 
  if ((PIN_BUTTON_READ&(1<<BUTTON_READ))==0)
	{ 
		_delay_ms(50);
		if ((PIN_BUTTON_READ&(1<<BUTTON_READ))==0) command_id=COMMAND_ID_READ_ID;
	}
  if ((PIN_BUTTON_WRITE&(1<<BUTTON_WRITE))==0)
	{
		_delay_ms(50);
		if ((PIN_BUTTON_WRITE&(1<<BUTTON_WRITE))==0)
			{
				command_id=COMMAND_ID_WRITE_ID;
				for(unsigned char n=0;n<5;n++) command_param[n]=LastReadingID[n];
			} 
	}
  sei();
  if (command_id==COMMAND_ID_READ_ID) ReadCardID();//  
  if (command_id==COMMAND_ID_WRITE_ID) WriteCardID(command_param);//   
  _delay_ms(10);
 } 
}
//----------------------------------------------------------------------------------------------------
// ID 
//----------------------------------------------------------------------------------------------------
void ReadCardID(void)
{
Duration=Duration/10;
Sound(); //    
Duration=Duration*10;
//   
DDR_LEDS|=(1<<LEDG_BIT); // 1=Pin OUT Mode
PORT_LEDS|=(1<<LEDG_BIT); // Pin Output State = 1

 _delay_ms(200);
 WH1602_SetTextUpLine("     ");
 WH1602_SetTextDownLine("Press> Read/Skip");
 _delay_ms(800);
 cli(); 
 RFIDFlags&=0xFF^DATA_ENABLED;//   
 sei();
 FieldOn();//  
 while (1)
 {   
  if (RFIDFlags&DATA_ENABLED)// RFID 
  {
	Sound(); //           
   //   
   WH1602_SetTextUpLine(" :   "); 
   WH1602_SetTextDownLine("                "); 
   char s_id[17]="                ";   
   int i=0;
   for(unsigned char n=0;n<5;n++,i+=3)
   {
    LastReadingID[n]=RFIDBuffer[n];
    char h=RFIDBuffer[n]>>4; 
    char l=RFIDBuffer[n]&0x0f; 
	if (h>=0 && h<=9) s_id[i]='0'+h;
	              else s_id[i]='A'+(h-10);
    if (l>=0 && l<=9) s_id[i+1]='0'+l;
	              else s_id[i+1]='A'+(l-10);
   }   
   WH1602_SetTextDownLine(s_id);   
   _delay_ms(200);
   break;
  }
  cli();
  if ((CommandID!=COMMAND_ID_NONE && CommandID!=COMMAND_ID_READ_ID) || ((PIN_BUTTON_READ&(1<<BUTTON_READ))==0))//  
  {
  _delay_ms(50);
  if ((CommandID!=COMMAND_ID_NONE && CommandID!=COMMAND_ID_READ_ID) || ((PIN_BUTTON_READ&(1<<BUTTON_READ))==0))
  {
	TONE=TONE*4;
	Duration=Duration/4;
	Sound(); //   
	TONE=TONE/4;
	Duration=Duration*4;
	
   WH1602_SetTextUpLine(" !");
   WH1602_SetTextDownLine("Press the KEY >>");
   sei();
   _delay_ms(500);
   break;
  }
  }
  sei();
  _delay_ms(10); 
 }
 FieldOff();//  
 LEDs_off(); //  
}
//----------------------------------------------------------------------------------------------------
// ID 
//----------------------------------------------------------------------------------------------------
void WriteCardID(unsigned char id[5])
{
Duration=Duration/10;
Sound(); //    
Duration=Duration*10;
//   
DDR_LEDS|=(1<<LEDR_BIT); // 1=Pin OUT Mode
PORT_LEDS|=(1<<LEDR_BIT); // Pin Output State = 1
  
 static unsigned char RFID_Send_Buffer[8];//  RFID
 static unsigned char RFID_Config[4];//  RFID

 unsigned char n;
 WH1602_SetTextUpLine(" !"); 
 char s_id[17]="                ";   
 int i=0;
 for(n=0;n<5;n++,i+=3)
 {
  char h=id[n]>>4; 
  char l=id[n]&0x0f; 
  if (h>=0 && h<=9) s_id[i]='0'+h;
                else s_id[i]='A'+(h-10);
  if (l>=0 && l<=9) s_id[i+1]='0'+l;
                else s_id[i+1]='A'+(l-10);
 }
 WH1602_SetTextDownLine(s_id);    
 //  em4305
 //  5  6  EM4305  UID (40     64 )
 //   
 RFIDBuffer[0]=id[0];
 RFIDBuffer[1]=id[1];
 RFIDBuffer[2]=id[2];
 RFIDBuffer[3]=id[3];
 RFIDBuffer[4]=id[4]; 
 PrepareSendBuffer(RFIDBuffer,RFID_Send_Buffer);
 // WriteEM4305Word    ,      - 
 for(n=0;n<8;n++)
 {
  unsigned char v=RFID_Send_Buffer[n];
  RFID_Send_Buffer[n]=0;
  unsigned char m;
  for(m=0;m<8;m++)
  {
   unsigned char m1=(1<<m);
   unsigned char m2=(128>>m);
   if (v&m1) RFID_Send_Buffer[n]|=m2;
  } 
 }
 
 FieldOn();//  
 _delay_ms(500);
 // 
 SendEM4305Login(0xFF,0xFF,0xFF,0xFF);
 //  (, RF/64,   6)
 WriteEM4305Word(4,0x5F,0x80,0x01,0x00);
 // ID    5  6
 WriteEM4305Word(5,RFID_Send_Buffer[0],RFID_Send_Buffer[1],RFID_Send_Buffer[2],RFID_Send_Buffer[3]); 
 WriteEM4305Word(6,RFID_Send_Buffer[4],RFID_Send_Buffer[5],RFID_Send_Buffer[6],RFID_Send_Buffer[7]); 
 FieldOff();//    
 _delay_ms(500);

 //  T5557/T5577  
 FieldOn();//  
 _delay_ms(500);
 //   
 RFID_Config[0]=0x00;
 RFID_Config[1]=0x14;
 RFID_Config[2]=0x80;
 RFID_Config[3]=0x40;
 //   
 RFIDBuffer[0]=id[0];
 RFIDBuffer[1]=id[1];
 RFIDBuffer[2]=id[2];
 RFIDBuffer[3]=id[3];
 RFIDBuffer[4]=id[4]; 
 //     
 PrepareSendBuffer(RFIDBuffer,RFID_Send_Buffer);
 WritePage(RFID_Send_Buffer);  
 WriteConfig(RFID_Config);  
 StartGap();
 WriteReset();
 WH1602_SetTextUpLine(" "); 
 _delay_ms(500);
 FieldOff();//  
Duration=Duration/2;  
 Sound(); //   
_delay_ms(100); 
 Sound(); //   
_delay_ms(100); 
 Sound(); //   
Duration=Duration*2;
LEDs_off(); //  
}

//----------------------------------------------------------------------------------------------------
//       
//----------------------------------------------------------------------------------------------------
void Skip_Info(void)
{
	for(unsigned char n=0;n<INFO_SPEED;n++)
	{
	_delay_ms(50); // DELAY ms ---> 50ms*INFO_SPEED = 50*80 = 4000ms
	//  
	counteref++;
	if (counteref >= LED_FLASH) 
		{
				counteref=0;
				if ((DDR_LEDS&(1<<LEDG_BIT))==0)
				{
				DDR_LEDS|=(1<<LEDG_BIT); // 1=Pin OUT Mode
				PORT_LEDS|=(1<<LEDG_BIT); // Pin Output State = 1
				DDR_LEDS&=~(1<<LEDR_BIT); // 0=Pin IN Mode
				PORT_LEDS&=~(1<<LEDR_BIT); // 0=HiZ
				}
				else
				{
				DDR_LEDS|=(1<<LEDR_BIT); // 1=Pin OUT Mode
				PORT_LEDS|=(1<<LEDR_BIT); // Pin Output State = 1
				DDR_LEDS&=~(1<<LEDG_BIT); // 0=Pin IN Mode
				PORT_LEDS&=~(1<<LEDG_BIT); // 0=HiZ
				}
				
		}
	
	if (((PIN_BUTTON_READ&(1<<BUTTON_READ))==0) || ((PIN_BUTTON_WRITE&(1<<BUTTON_WRITE))==0))
	{
	_delay_ms(100);
	if (((PIN_BUTTON_READ&(1<<BUTTON_READ))==0) || ((PIN_BUTTON_WRITE&(1<<BUTTON_WRITE))==0))
		{
			_delay_ms(200);
			skip=1;
			break;
		}
	} // if END
	} // for END
} // void END
 
 
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// 
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 
//----------------------------------------------------------------------------------------------------
// 
//----------------------------------------------------------------------------------------------------
void InitAVR(void)
{
 // 
 DDRB=0;
 DDRD=0;
 DDRC=0; 
 //  
 PORTB=0;
 PORTD=0;
 PORTC=0;
 //  
 DDR_COIL|=(1<<COIL_BIT);

  
 //  T1  ,   OC1A      125 
 TCNT1=0;//  
 TIMSK=(0<<TOIE1);//      ( T1 16 )
 TCCR1A=TCCR1A_FIELD_OFF;//(0<<COM1A1)|(1<<COM1A0)|(0<<COM1B1)|(0<<COM1B0)|(0<<FOC1A)|(0<<FOC1B)|(0<<WGM11)|(0<<WGM10);
 //COM1A1=0, COM1A0=1 -   OC1A   
 TCCR1B=TCCR1B_FIELD_OFF;//(0<<ICNC1)|(1<<ICES1)|(0<<WGM13)|(1<<WGM12)|(0<<CS12)|(1<<CS11)|(0<<CS10);
 //CS12=0, CS11=1, CS10=0 -     8
 //WGM13=0, WGM12=1, WGM11=0, WGM10=0 -       OCR1A
 OCR1A=F_CPU/(2*8*125000)-1;//  F=Fclock/(2*N*(1+OCR1A))
 OCR1B=0;
 
 
 //  
 ACSR=(0<<ACD)|(0<<ACBG)|(0<<ACO)|(0<<ACI)|(1<<ACIE)|(0<<ACIC)|(0<<ACIS1)|(0<<ACIS0);
 //ACD -   (0 - ר!)
 //ACBG -       '
 //ACO -   ( )
 //ACI -    
 //ACIE -    
 //ACIC -       T1
 //ACIS1,ACID0 -     
 
 
 //  T0   1 
 TCCR0=((0<<CS02)|(1<<CS01)|(1<<CS00));//      64 (  125 000)
 TCNT0=0;//   
 TIMSK|=(1<<TOIE0);//    ( T0 )  
 
 
 //    
 // PORTx Pin = 0  ---> PORTx &= ~(1<<BIT);   /   PORTx &= ~_BV(PxBIT);      
 // PORTx Pin = 1  ---> PORTx |= 1<<BIT;   /   PORTx |= _BV(PxBIT);
 DDR_BUTTON_READ&=~(1<<BUTTON_READ); // 0=Pin IN Mode / 1=Pin OUT Mode
 PORT_BUTTON_READ|=(1<<BUTTON_READ); // If DDR=1 OUT Mode ---> Pin Output State 0 or 1 / If DDR=0 IN Mode ---> 0=HiZ or 1=PullUp 

 DDR_BUTTON_WRITE&=~(1<<BUTTON_WRITE); // 0=Pin IN Mode / 1=Pin OUT Mode
 PORT_BUTTON_WRITE|=(1<<BUTTON_WRITE); // If DDR=1 OUT Mode ---> Pin Output State 0 or 1 / If DDR=0 IN Mode ---> 0=HiZ or 1=PullUp
 
 //    
 DDR_BUZ|=(1<<BUZ_BIT); // 1=Pin OUT Mode
 PORT_BUZ&=~(1<<BUZ_BIT); // Pin Output State = 0
 //PORT_BUZ|=(1<<BUZ_BIT); // Pin Output State = 1
 
 //    
 LEDs_off(); //  
 
}

//----------------------------------------------------------------------------------------------------
// 
//----------------------------------------------------------------------------------------------------
void LEDs_off(void)
{
//    
 
 //   - 
 DDR_LEDS&=~(1<<LEDG_BIT); // 0=Pin IN Mode
 PORT_LEDS&=~(1<<LEDG_BIT); // 0=HiZ
 //DDR_LEDS|=(1<<LEDG_BIT); // 1=Pin OUT Mode
 //PORT_LEDS|=(1<<LEDG_BIT); // Pin Output State = 1
 
  //   - 
 DDR_LEDS&=~(1<<LEDR_BIT); // 0=Pin IN Mode
 PORT_LEDS&=~(1<<LEDR_BIT); // 0=HiZ
 //DDR_LEDS|=(1<<LEDR_BIT); // 1=Pin OUT Mode
 //PORT_LEDS|=(1<<LEDR_BIT); // Pin Output State = 1
}

//----------------------------------------------------------------------------------------------------
// -   
//----------------------------------------------------------------------------------------------------
void Sound(void)
{
	for(int n=0;n<Duration;n++)
		{
		PORT_BUZ|=(1<<BUZ_BIT); // Pin Output State = 1
		_delay_us(TONE);
		PORT_BUZ&=~(1<<BUZ_BIT); // Pin Output State = 0
		_delay_us(TONE);		
		}
}

//----------------------------------------------------------------------------------------------------
//   COM-
//----------------------------------------------------------------------------------------------------
void UART_Write(unsigned char byte)
{ 
 while(!(UCSRA&(1<<UDRE)));
 UDR=byte;
}
