 
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 
//    RFID (  /(__T0*_RFID_)
#define RFID_PERIOD_LENGTH (F_CPU/64/2000)

//    0
#define TIMER0_OVERFLOW		(1<<0)
//   RFID 
#define	DATA_ENABLED		(1<<1)
//    
#define LINE_ONE_VALUE		(1<<2)

//  T1    
#define TCCR1A_FIELD_ON ((0<<COM1A1)|(1<<COM1A0)|(0<<COM1B1)|(0<<COM1B0)|(0<<FOC1A)|(0<<FOC1B)|(0<<WGM11)|(0<<WGM10))
#define TCCR1B_FIELD_ON ((0<<ICNC1)|(1<<ICES1)|(0<<WGM13)|(1<<WGM12)|(0<<CS12)|(1<<CS11)|(0<<CS10))

//  T1    
#define TCCR1A_FIELD_OFF 0
#define TCCR1B_FIELD_OFF 0

//----------------------------------------------------------------------------------------------------
// 
//----------------------------------------------------------------------------------------------------
 
unsigned char RFIDBuffer[5]; //    RFID  
volatile unsigned char RFIDFlags;//  

//----------------------------------------------------------------------------------------------------
// 
//----------------------------------------------------------------------------------------------------
void FirstFieldStop_4305(void);// FirstFieldStop  em4305
void SendOne_4305(void);//   em4305
void SendZero_4305(void);//   em4305
void SendEM4305DataBlock(char b0,char b1,char b2,char b3);//  Em4305   32 
void SendEM4305Login(char b0,char b1,char b2,char b3);//  Em4305 
void WriteEM4305Word(unsigned char addr,char b0,char b1,char b2,char b3);//   Em4305

void FieldOn(void);// 
void FieldOff(void);// 
void StartGap(void);// Start Gap
void SendOne(void);// 
void SendZero(void);// 
void OpCode_LockBit(void);//  lock bit
void WriteReset(void);// 
void AddressSelect(unsigned char data);// 
void WritePage(unsigned char *data);// 
void WriteConfig(unsigned char *data);// 
unsigned char CalculateCRC(unsigned char *buffer);// CRC
void PrepareSendBuffer(unsigned char *source_data,unsigned char *send_data);//  
 
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// 
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  
//----------------------------------------------------------------------------------------------------
// FirstFieldStop  em4305
//----------------------------------------------------------------------------------------------------
void FirstFieldStop_4305(void)
{
 FieldOff();
 _delay_us(6*8);
 FieldOn();
 _delay_us(12*8); 
 FieldOff();
 _delay_us(40*8); 
 FieldOn();
 _delay_us(17*8);
 FieldOff();
}
 
//----------------------------------------------------------------------------------------------------
//   em4305
//----------------------------------------------------------------------------------------------------
void SendOne_4305(void)
{
 FieldOn();
 _delay_us(30*8);
}
//----------------------------------------------------------------------------------------------------
//   em4305
//----------------------------------------------------------------------------------------------------
void SendZero_4305(void)
{
 FieldOff();
 _delay_us(18*8);
 FieldOn();        
 _delay_us(17*8); 
}
//----------------------------------------------------------------------------------------------------
//  Em4305   32 
//----------------------------------------------------------------------------------------------------
void SendEM4305DataBlock(char b0,char b1,char b2,char b3)
{
 unsigned char n;
 unsigned char data[4]={b0,b1,b2,b3};
 // 
 unsigned char p=0; 
 for(n=0;n<4;n++)
 {
  unsigned char l_p=0;
  p^=data[n];
  for(unsigned char m=0;m<8;m++)
  {
   unsigned char mask=(1<<m);
   if (data[n]&mask)
   {
    SendOne_4305();
	l_p^=1;
   }
   else SendZero_4305();   
  }
  //     
  if (l_p==0) SendZero_4305();
         else SendOne_4305();
 }
 //   		  
 for(n=0;n<8;n++)
 {
  unsigned char mask=(1<<n);
  if (p&mask) SendOne_4305();
         else SendZero_4305();   
 }
 // 0
 SendZero_4305(); 
 FieldOn();
 _delay_ms(500);
}
//----------------------------------------------------------------------------------------------------
//  Em4305 
//----------------------------------------------------------------------------------------------------
void SendEM4305Login(char b0,char b1,char b2,char b3)
{
 FirstFieldStop_4305(); 
 SendZero_4305();//'0'
 // 0011
 SendZero_4305();//CC0
 SendZero_4305();//CC1
 SendOne_4305();//CC2
 SendOne_4305();//P
 // 
 SendEM4305DataBlock(b0,b1,b2,b3);
}
//----------------------------------------------------------------------------------------------------
//   Em4305
//----------------------------------------------------------------------------------------------------
void WriteEM4305Word(unsigned char addr,char b0,char b1,char b2,char b3)
{
 //HIGHT -  
 FirstFieldStop_4305(); 
 SendZero_4305();//'0'
 // 0101
 SendZero_4305();//CC0
 SendOne_4305();//CC1
 SendZero_4305();//CC2
 SendOne_4305();//P
 //   (  )
 unsigned char p=0;
 for(unsigned char n=0;n<4;n++)
 {
  if (addr&(1<<n))
  {
   SendOne_4305();
   p^=1;
  }
  else SendZero_4305();
 }
 //    
 SendZero_4305();
 SendZero_4305();
 if (p==0) SendZero_4305();
      else SendOne_4305(); 
 // 
 SendEM4305DataBlock(b0,b1,b2,b3);
}

  
  
//----------------------------------------------------------------------------------------------------
// 
//----------------------------------------------------------------------------------------------------
void FieldOn(void)
{
 TCCR1A=TCCR1A_FIELD_ON; 
 TCCR1B=TCCR1B_FIELD_ON; 
}
//----------------------------------------------------------------------------------------------------
// 
//----------------------------------------------------------------------------------------------------
void FieldOff(void)
{
 TCCR1A=TCCR1A_FIELD_OFF; 
 TCCR1B=TCCR1B_FIELD_OFF; 
}
 
//----------------------------------------------------------------------------------------------------
// Start Gap
//----------------------------------------------------------------------------------------------------
void StartGap(void)
{
 FieldOff();
 _delay_us(350);
 FieldOn();
}
 
//----------------------------------------------------------------------------------------------------
// 
//----------------------------------------------------------------------------------------------------
void SendOne(void)
{
 _delay_us(420-80);
 FieldOff();
 _delay_us(300-80);
 FieldOn();        
}
//----------------------------------------------------------------------------------------------------
// 
//----------------------------------------------------------------------------------------------------
void SendZero(void)
{
 _delay_us(150-80);
 FieldOff();
 _delay_us(300-80);
 FieldOn();        
}
//----------------------------------------------------------------------------------------------------
//  lock bit
//----------------------------------------------------------------------------------------------------
void OpCode_LockBit(void)
{
 SendOne();
 SendZero();
 SendZero();
}
//----------------------------------------------------------------------------------------------------
// 
//----------------------------------------------------------------------------------------------------
void WriteReset(void)
{
 SendZero();
 SendZero();
}
//----------------------------------------------------------------------------------------------------
// 
//----------------------------------------------------------------------------------------------------
void AddressSelect(unsigned char data)
{
 if (data&(1<<2)) SendOne(); 
              else SendZero();
 if (data&(1<<1)) SendOne();
              else SendZero();
 if (data&(1<<0)) SendOne();
              else SendZero();
}
//----------------------------------------------------------------------------------------------------
// 
//----------------------------------------------------------------------------------------------------
void WritePage(unsigned char *data)
{
 int i;
 int j;
 StartGap();
 OpCode_LockBit();
 for(i=0;i<4;i++) 
 {
  for(j=7;j>=0;j--) 
  {
   if (data[i]&(1<<j)) SendOne();
                   else SendZero();
  }
 } 
 AddressSelect(1);
 _delay_ms(100);
 StartGap();
 OpCode_LockBit();
 for(i=4;i<8;i++) 
 {
  for(j=7;j>=0;j--) 
  {
   if (data[i]&(1<<j)) SendOne();
                   else SendZero();
  }
 }
 AddressSelect(2);
 _delay_ms(100);
}
//----------------------------------------------------------------------------------------------------
// 
//----------------------------------------------------------------------------------------------------
void WriteConfig(unsigned char *data)
{
 int i;
 int j;
 StartGap();
 OpCode_LockBit();
 for (i=0;i<4;i++) 
 {
  for (j=7;j>=0;j--) 
  {
   if (data[i]&(1<<j)) SendOne(); 
                   else SendZero(); 
  }
 }
 AddressSelect(0);
 _delay_ms(100);
}
//----------------------------------------------------------------------------------------------------
// CRC
//----------------------------------------------------------------------------------------------------
unsigned char CalculateCRC(unsigned char *buffer)
{
 int i;
 unsigned char crc=0;
 for(i=0;i<5;i++)
 {
  crc=crc^(buffer[i]&0x0F)^((buffer[i]>>4)&0x0F); 
 }
 return(crc); 
} 
//----------------------------------------------------------------------------------------------------
//  
//----------------------------------------------------------------------------------------------------
void PrepareSendBuffer(unsigned char *source_data,unsigned char *send_data)
{
 unsigned char source_bits=0;
 unsigned char send_bits=9;
 send_data[0]=0xFF;// 8 
 send_data[1]=0x80;//     
 send_data[2]=0;
 send_data[3]=0;
 send_data[4]=0;
 send_data[5]=0;
 send_data[6]=0;
 send_data[7]=0;
 do  
 {
  char j=0;
  unsigned char send_crc=0;
  do 
  {
   unsigned char bit=0;
   if (source_data[source_bits/8]&(1<<(7-(source_bits%8)))) bit=1;
   send_crc=send_crc^bit;
   if (bit==1) send_data[send_bits/8]|=(1<<(7-(send_bits%8)));
   source_bits++;
   send_bits++;
   j++;
  } while(j<4);
  if (send_crc==1) send_data[send_bits/8]|=(1<<(7-send_bits%8));
  send_bits++;
 } while(source_bits<40);
 send_data[7]|=(CalculateCRC(source_data)<<1);
}
 
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//  
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  
//----------------------------------------------------------------------------------------------------
//    T0 (8-  )  
//----------------------------------------------------------------------------------------------------
ISR(TIMER0_OVF_vect)
{   
 if (ACSR&(1<<ACIE)) RFIDFlags|=TIMER0_OVERFLOW;//    ,     
 else
 {
  //    
  if (!(ACSR&(1<<ACO))) RFIDFlags|=LINE_ONE_VALUE;
  else RFIDFlags&=0xFF^LINE_ONE_VALUE;
  ACSR|=(1<<ACI);//   (   1)
  ACSR|=(1<<ACIE);// 
 }
} 
 
//----------------------------------------------------------------------------------------------------
//    
//----------------------------------------------------------------------------------------------------
ISR(ANA_COMP_vect)
{
 static unsigned char BitCounter=0;//    
 static unsigned char GroupNumber=0;//   (0 -  , 1-5 , 6    )
 static unsigned char BitMask=0;//   (0x80 - 0x01)
 static unsigned char ReceivedByte=0;// 
 static unsigned char ParityVertical=0;//    	
 static unsigned char ParityHorizontal=0;//     
  
 unsigned char TimerTemp=TCNT0;
 TCNT0=0x100-(RFID_PERIOD_LENGTH*3/4);//     3\4   RFID  
 ACSR&=0xFF^(1<<ACIE);//  
 ACSR|=(1<<ACI);//   ,    
  
 char value=0xff;
 if (RFIDFlags&LINE_ONE_VALUE) value=0; 
  
 BitCounter++;
 if ((TimerTemp>(RFID_PERIOD_LENGTH/2)) || (RFIDFlags&TIMER0_OVERFLOW))//          RFID
 {  
  //   
  RFIDFlags&=0xFF^TIMER0_OVERFLOW;
  BitCounter=1;
  GroupNumber=0;
 }  
 //     
 if (GroupNumber==0)
 {								
  if (value==0)//,     
  {
   //    
   BitCounter=0;
   GroupNumber=0;
   return;
  }
  if (BitCounter>=9)//  
  {
   //     
   BitCounter=0;
   GroupNumber=1;
   BitMask=0x80;	
   ReceivedByte=0;
   ParityHorizontal=0;
   ParityVertical=0;
  }	 
  return;
 }
  
 //   (   10     )
 if (BitCounter==5)//  - 
 {  
  if (GroupNumber<6)//    
  {						
   // 1-5   
   if ((ParityHorizontal&&value)||((!ParityHorizontal)&&(!value)))// 
   {
    //     
    ParityHorizontal=0;
    return;
   }
   //  
   BitCounter=0;
   GroupNumber=0;
   return;
  }
  else//  -    
  {   
   if (ReceivedByte==ParityVertical)//    
   {
    for (unsigned char n=0;n<5;n++)
    {
     if (RFIDBuffer[n])//      (  - )
     {
      RFIDFlags|=DATA_ENABLED; 	//   
      break;
     }
    }
   }
   //  
   BitCounter=0;
   GroupNumber=0;
   return;						
  }
 }  
 if (BitCounter==10) //  10-  
 {					
  //    
  if ((ParityHorizontal&&value)||((!ParityHorizontal)&&(!value)))
  {
   ParityVertical^=(ReceivedByte&0xf0);//    
   ParityVertical^=(ReceivedByte<<4);
   ParityHorizontal=0;//      
   if (RFIDFlags&DATA_ENABLED)//     
   {
    //  
    BitCounter=0;
    GroupNumber=0;
    return;   
   }   
   RFIDBuffer[GroupNumber-1]=ReceivedByte;//    
   ReceivedByte=0;
   BitMask=0x80;
   GroupNumber++; 
   BitCounter=0;
   return;
  }
  //  
  BitCounter=0;
  GroupNumber=0;
  return;   
 }
 //   5-   10- ,   
 if (value)//  
 {
  ReceivedByte|=BitMask;
  ParityHorizontal^=0x01;//   
 }
 BitMask>>=1;   
}