//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// 
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#define WH1602_RS_PORT    PORTB
#define WH1602_RS_DDR     DDRB
#define WH1602_RS         5

#define WH1602_E_PORT      PORTC
#define WH1602_E_DDR       DDRC
#define WH1602_E           1

#define WH1602_DB7_PORT  PORTC
#define WH1602_DB7_DDR   DDRC
#define WH1602_DB7       5

#define WH1602_DB6_PORT  PORTC
#define WH1602_DB6_DDR   DDRC
#define WH1602_DB6       4

#define WH1602_DB5_PORT  PORTC
#define WH1602_DB5_DDR   DDRC
#define WH1602_DB5       3

#define WH1602_DB4_PORT  PORTC
#define WH1602_DB4_DDR   DDRC
#define WH1602_DB4       2


//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//   
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
unsigned char RusCodeTable[66][2] PROGMEM=
{
 {'','A'},
 {'',0b10100000},
 {'','B'},
 {'',0b10100001},
 {'',0b11100000},
 {'','E'},
 {'',0b10100010},
 {'',0b10100011},
 {'',0b10100100},
 {'',0b10100101},
 {'',0b10100110},
 {'','K'},
 {'',0b10100111},
 {'','M'},
 {'','H'},
 {'','O'},
 {'',0b10101000},
 {'','P'},
 {'','C'},
 {'','T'},
 {'',0b10101001},
 {'',0b10101010},
 {'','X'},
 {'',0b11100001},
 {'',0b10101011},
 {'',0b10101100},
 {'',0b11100010},
 {'',0b10101101},
 {'',0b10101110},
 {'','b'},
 {'',0b10101111},
 {'',0b10110000},
 {'',0b10110001},
 
 {'','a'},
 {'',0b10110010},
 {'',0b10110011},
 {'',0b10110100},
 {'',0b11100011},
 {'','e'},
 {'',0b10110101},
 {'',0b10110110},
 {'',0b10110111},
 {'',0b10111000},
 {'',0b10111001},
 {'',0b10111010},
 {'',0b10111011},
 {'',0b10111100},
 {'',0b10111101},
 {'','o'},
 {'',0b10111110},
 {'','p'},
 {'','c'},
 {'',0b10111111},
 {'','y'},
 {'',0b11100100},
 {'','x'},
 {'',0b11100101},
 {'',0b11000000},
 {'',0b11000001},
 {'',0b11100110},
 {'',0b11000010},
 {'',0b11000011},
 {'',0b11000100},
 {'',0b11000101},
 {'',0b11000110},
 {'',0b11000111}
};

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// 
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

void WH1602_Init(void);// 
void WH1602_SendNibble(unsigned char nibble);// 
void WH1602_SendData(unsigned char byte);// 
void WH1602_SendCommand(unsigned char byte);// 
void WH1602_SetTextUpLine(char *text);//     
void WH1602_SetTextDownLine(char *text);//     
void WH1602_SetTextProgmemUpLine(const char *text);//       
void WH1602_SetTextProgmemDownLine(const char *text);//       

//----------------------------------------------------------------------------------------------------
// 
//----------------------------------------------------------------------------------------------------
void WH1602_Init(void)
{
 //  
 WH1602_RS_DDR|=(1<<WH1602_RS);
 WH1602_E_DDR|=(1<<WH1602_E);
 WH1602_DB7_DDR|=(1<<WH1602_DB7);
 WH1602_DB6_DDR|=(1<<WH1602_DB6);
 WH1602_DB5_DDR|=(1<<WH1602_DB5);
 WH1602_DB4_DDR|=(1<<WH1602_DB4);
 _delay_ms(60);//  
 // 
 //    
 WH1602_RS_PORT&=0xff^(1<<WH1602_RS);// 
 WH1602_SendNibble(0b0011);// 
 _delay_ms(15); 
 WH1602_SendNibble(0b0011);// 
 _delay_us(600);  
 WH1602_SendNibble(0b0011);//  
 WH1602_SendNibble(0b0010);// 4  
 //  4 , 2 ,  5x11
 WH1602_SendCommand(0b00101100);
 _delay_ms(4);
 // 
 WH1602_SendCommand(0b00001000);
 _delay_ms(4); 
 //  
 WH1602_SendCommand(0b00000001);
 _delay_ms(4); 
 //       
 WH1602_SendCommand(0b00000110);
 // 
 WH1602_SendCommand(0b00001100);
 _delay_ms(4);  
}
//----------------------------------------------------------------------------------------------------
// 
//----------------------------------------------------------------------------------------------------
void WH1602_SendNibble(unsigned char nibble)
{ 
 WH1602_DB7_PORT&=0xff^(1<<WH1602_DB7);
 WH1602_DB6_PORT&=0xff^(1<<WH1602_DB6);
 WH1602_DB5_PORT&=0xff^(1<<WH1602_DB5);
 WH1602_DB4_PORT&=0xff^(1<<WH1602_DB4);
 WH1602_E_PORT|=(1<<WH1602_E); 
 WH1602_DB7_PORT|=(((nibble>>3)&0x01)<<WH1602_DB7);
 WH1602_DB6_PORT|=(((nibble>>2)&0x01)<<WH1602_DB6);
 WH1602_DB5_PORT|=(((nibble>>1)&0x01)<<WH1602_DB5);
 WH1602_DB4_PORT|=(((nibble>>0)&0x01)<<WH1602_DB4);
 _delay_us(300); 
 WH1602_E_PORT&=0xff^(1<<WH1602_E);
 _delay_us(300); 
}
//----------------------------------------------------------------------------------------------------
// 
//----------------------------------------------------------------------------------------------------
void WH1602_SendData(unsigned char byte)
{
 WH1602_RS_PORT|=1<<WH1602_RS;//   
 WH1602_SendNibble(byte>>4);
 WH1602_SendNibble(byte&0x0f);
}
//----------------------------------------------------------------------------------------------------
// 
//----------------------------------------------------------------------------------------------------
void WH1602_SendCommand(unsigned char byte)
{
 WH1602_RS_PORT&=0xff^(1<<WH1602_RS);// 
 WH1602_SendNibble(byte>>4);
 WH1602_SendNibble(byte&0x0f);
}
//----------------------------------------------------------------------------------------------------
//     
//----------------------------------------------------------------------------------------------------
void WH1602_SetTextUpLine(char *text)
{
 //  
 WH1602_SendCommand(0b10000000);//    0
 _delay_us(300); 
 //  
 unsigned char n;
 unsigned char out_text[16];
 for(n=0;n<16;n++)
 {
  unsigned char b=text[n];
  out_text[n]=b;
  for(unsigned char m=0;m<66;m++)
  {
   unsigned char t=pgm_read_byte(&(RusCodeTable[m][0]));
   if (t==b)
   {
    out_text[n]=pgm_read_byte(&(RusCodeTable[m][1]));
	break;
   }
  }
 } 
 for(n=0;n<16;n++)
 {
  if (text[n]==0) break;  
  WH1602_SendData(out_text[n]);
 }
 for(;n<16;n++) WH1602_SendData(32);// 
}
//----------------------------------------------------------------------------------------------------
//     
//----------------------------------------------------------------------------------------------------
void WH1602_SetTextDownLine(char *text)
{
 //  
 WH1602_SendCommand(0b10101000);//    40
 _delay_us(300); 
 //  
 unsigned char n;
 unsigned char out_text[16];
 for(n=0;n<16;n++)
 {
  unsigned char b=text[n];
  out_text[n]=b;
  for(unsigned char m=0;m<66;m++)
  {
   unsigned char t=pgm_read_byte(&(RusCodeTable[m][0]));
   if (t==b)
   {
    out_text[n]=pgm_read_byte(&(RusCodeTable[m][1]));
	break;
   }
  }
 } 
 for(n=0;n<16;n++)
 {
  if (text[n]==0) break;  
  WH1602_SendData(out_text[n]);
 }
 for(;n<16;n++) WH1602_SendData(32);// 
}
//----------------------------------------------------------------------------------------------------
//       
//----------------------------------------------------------------------------------------------------
void WH1602_SetTextProgmemUpLine(const char *text)
{
 //  
 WH1602_SendCommand(0b10000000);//    0
 _delay_us(300); 
 //  
 unsigned char n;
 unsigned char out_text[16];
 for(n=0;n<16;n++)
 {
  unsigned char b=pgm_read_byte(&text[n]);
  out_text[n]=b;
  for(unsigned char m=0;m<66;m++)
  {
   unsigned char t=pgm_read_byte(&(RusCodeTable[m][0]));
   if (t==b)
   {
    out_text[n]=pgm_read_byte(&(RusCodeTable[m][1]));
	break;
   }
  }
 } 
 for(n=0;n<16;n++)
 {
  if (pgm_read_byte(&text[n])==0) break;  
  WH1602_SendData(out_text[n]);
 }
 for(;n<16;n++) WH1602_SendData(32);// 
}
//----------------------------------------------------------------------------------------------------
//        
//----------------------------------------------------------------------------------------------------
void WH1602_SetTextProgmemDownLine(const char *text)
{
 //  
 WH1602_SendCommand(0b10101000);//    40
 _delay_us(300); 
 //  
 unsigned char n;
 unsigned char out_text[16];
 for(n=0;n<16;n++)
 {
  unsigned char b=pgm_read_byte(&text[n]);
  out_text[n]=b;
  for(unsigned char m=0;m<66;m++)
  {
   unsigned char t=pgm_read_byte(&(RusCodeTable[m][0]));
   if (t==b)
   {
    out_text[n]=pgm_read_byte(&(RusCodeTable[m][1]));
	break;
   }
  }
 } 
 for(n=0;n<16;n++)
 {
  if (pgm_read_byte(&text[n])==0) break;  
  WH1602_SendData(out_text[n]);
 }
 for(;n<16;n++) WH1602_SendData(32);// 
}


